//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "znetadv.h"
#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    int times;
    char szip[20];
    char szver[20];
    char szmac[30];
    BYTE devtype;
    BYTE ipmode;
    int tcpport;
    TListItem* item;

	ClearDevices();
	ZN_SearchAll();
    times=200;
	while(times>0)
    {
		while(ZN_GetSearchDev(szip,szver,szmac,&devtype,&ipmode,&tcpport)==1)
		{
          item=ListView_Dev->Items->Add();
          item->Data=Pointer(devtype);
          item->Caption=szip;
          item->SubItems->Add(GetDevType(devtype));
          item->SubItems->Add(szmac);
          if(devtype>=48)
              item->SubItems->Add(IntToStr(tcpport));
          else
              item->SubItems->Add("");
		}
		Sleep(10);
        times=times-1;
	}
}
//---------------------------------------------------------------------------


void TForm1::ClearDevices()
{
    //TODO: Add your source code here
    ListView_Dev->Items->Clear();
}

AnsiString TForm1::GetDevType(BYTE devtype)
{
    AnsiString strtype;
    BYTE devarr[20];
    AnsiString namearr[20];
    int i;
    devarr[0] = 1;
    devarr[1] = 2;
    devarr[2] = 3;
    devarr[3] = 4;
    devarr[4] = 5;
    devarr[5] = 6;
    devarr[6] = 7;
    devarr[7] = 8;
    devarr[8] = 17;
    devarr[9] = 18;
    devarr[10] = 19;
    devarr[11] = 20;
    devarr[12] = 21;
    devarr[13] = 22;
    devarr[14] = 23;
    devarr[15] = 48;


    namearr[0] = "ZNE-100";
    namearr[1] = "ZNE-100T";
    namearr[2] = "ZNE-10";
    namearr[3] = "ZNE-200T";
    namearr[4] = "NETCOM-10";
    namearr[5] = "ZNE-200";
    namearr[6] = "ZNE-10T";
    namearr[7] = "ZNE-100TI";
    namearr[8] = "CANET-E";
    namearr[9] = "CANET-100";
    namearr[10] = "CANET-200";
    namearr[11] = "CANET-100T";
    namearr[12] = "CANET-200T";
    namearr[13] = "CANET_ET";
    namearr[14] = "CANET_2ET";
    namearr[15] = "NETCOM-400";


    strtype = IntToStr(devtype);
    for(i= 0;i<12;i++)
    {
        if(devarr[i]==devtype)
            strtype = strtype + "(" + namearr[i] + ")";
    }
    return strtype;
}
void __fastcall TForm1::Button2Click(TObject *Sender)
{
    int selind;
    AnsiString szip,szmac,str1;
    BYTE devtype;
    int tcpport,res;

    selind = TryGetSelDev();
    if(selind == -1)
        return;
    szip=ListView_Dev->Items->Item[selind]->Caption;
    str1=((ListView_Dev->Items->Item[selind]->SubItems)->Strings[0]);
    devtype=BYTE(ListView_Dev->Items->Item[selind]->Data);
    szmac=ListView_Dev->Items->Item[selind]->SubItems->Strings[1];
    str1=ListView_Dev->Items->Item[selind]->SubItems->Strings[2];
    if(str1!="")
        tcpport = StrToInt(str1);
        
    if(devtype == 17 ||devtype == 18 ||devtype == 19)
        res = GetInfo_CanOld(szmac, devtype, szip);
    else if (devtype == 20 ||devtype == 21 ||devtype == 22 ||devtype == 23)
        res = GetInfo_CanNew(szmac, devtype,szip);
    else
        ShowMessage ("ֵ֧ģ");

    if (res != 1)
        ShowMessage ("ȡϢʧ");
    else
        ShowMessage ("ȡϢɹ");
}
//---------------------------------------------------------------------------


int TForm1::TryGetSelDev()
{
    if(ListView_Dev->SelCount==0)
    {
        ShowMessage ("ѡһ豸");
        return -1;
    }
    return ListView_Dev->Selected->Index;
}

int TForm1::GetInfo_CanNew(AnsiString szmac, BYTE devtype, AnsiString szip)
{
    if (ZN_GetDevInfoUDPbyMACAndIP(szmac.c_str() ,szip.c_str() ,devtype) != 1)
        return 0;

    char szval[32];
       
    if (ZN_GetDevConfigUDP("NAME", szval) != 1)
        return 0;
    Edit_Name->Text =szval;

    if (ZN_GetDevConfigUDP("CAN1_WORK_PORT", szval) != 1)
        return 0;
    Edit_Work_Port->Text =szval;

    if (ZN_GetDevConfigUDP("CAN1_DES_IP1", szval) != 1)
        return 0;
    Edit_Desip_1->Text =szval;

    if (ZN_GetDevConfigUDP("CAN1_DES_PORT1", szval) != 1)
        return 0;
    Edit_DesPort_1->Text =szval;

    if (ZN_GetDevConfigUDP("CAN1_BAUD", szval) != 1)
        return 0;
    Edit_Can_Baud->Text =szval;

    if (ZN_GetDevConfigUDP("CAN1_LISTEN_MD", szval) != 1)
        return 0;
    Edit_Can_Mode->Text =szval;

    return 1;
}

int TForm1::GetInfo_CanOld(AnsiString szmac, BYTE devtype, AnsiString szip)
{
      if (ZN_GetDevInfoUDPbyMACAndIP(szmac.c_str(),   szip.c_str(), devtype) != 1)
        return 0;

    char szval[32];
       
    if (ZN_GetDevConfigUDP("NAME", szval) != 1)
        return 0;
    Edit_Name->Text =szval;

    if (ZN_GetDevConfigUDP("C1_PORT", szval) != 1)
        return 0;
    Edit_Work_Port->Text =szval;

    if (ZN_GetDevConfigUDP("CANDESIP1", szval) != 1)
        return 0;
    Edit_Desip_1->Text =szval;

    if (ZN_GetDevConfigUDP("CANDESPORT1", szval) != 1)
        return 0;
    Edit_DesPort_1->Text =szval;

    if (ZN_GetDevConfigUDP("CANBAUD1", szval) != 1)
        return 0;
    Edit_Can_Baud->Text =szval;

    if (ZN_GetDevConfigUDP("CANLISTENMD1", szval) != 1)
        return 0;
    Edit_Can_Mode->Text =szval;

    return 1;
}
void __fastcall TForm1::Button3Click(TObject *Sender)
{
    int selind;
    AnsiString szip,szmac,str1;
    BYTE devtype;
    int tcpport;
    int res;

    selind = TryGetSelDev();
    if(selind == -1)
        return;
    szip=ListView_Dev->Items->Item[selind]->Caption;
    str1=ListView_Dev->Items->Item[selind]->SubItems->Strings[0];
    devtype=BYTE(ListView_Dev->Items->Item[selind]->Data);        
    szmac=ListView_Dev->Items->Item[selind]->SubItems->Strings[1];
    str1=ListView_Dev->Items->Item[selind]->SubItems->Strings[2];
    if(str1!="")
        tcpport = StrToInt(str1);

        
    if(devtype == 17 ||devtype == 18 ||devtype == 19)
        res = Modify_CanOld(szmac, devtype, szip);
    else if (devtype == 20 ||devtype == 21 ||devtype == 22 ||devtype == 23)
        res = Modify_CanNew(szmac, devtype, szip);
    else
        ShowMessage ("ֵ֧ģ");

    if (res != 1)
        ShowMessage ("Ϣʧ");
    else
        ShowMessage ("Ϣɹ");
    
}
//---------------------------------------------------------------------------


int TForm1::Modify_CanNew(AnsiString szmac, BYTE devtype, AnsiString szip)
{
    int res;
    AnsiString szpwd;

    Form2->ShowModal();
    if(Form2->isOK() == 0)
        return 0;
    szpwd = Form2->Edit1->Text;
    
    ZN_ResetModifyConfigUDP();
    if (ZN_SetModifyConfigUDP("CAN1_WORK_PORT",Edit_Work_Port->Text.c_str()) != 1)
        return 0;

    if (ZN_SetModifyConfigUDP("CAN1_DES_IP1",Edit_Desip_1->Text.c_str() ) != 1)
        return 0;

    if (ZN_SetModifyConfigUDP("CAN1_DES_PORT1", Edit_DesPort_1->Text.c_str()) != 1)
        return 0;

    if (ZN_SetModifyConfigUDP("CAN1_BAUD",Edit_Can_Baud->Text.c_str()) != 1)
    	return 0;

    if (ZN_SetModifyConfigUDP("CAN1_LISTEN_MD", Edit_Can_Mode->Text.c_str()) != 1)
	return 0;

    if (ZN_ModifyDevUDPbyMACAndIP(szmac.c_str(), szip.c_str(), szpwd.c_str(), devtype) != 1)
    	return 0;
	
    Sleep(4000);
	//УǷĳɹ
    if (ZN_GetDevInfoUDPbyMACAndIP(szmac.c_str(),  szip.c_str(), devtype) != 1)
        return 0;

    char szval[32];
    //˿
    if (ZN_GetDevConfigUDP("CAN1_WORK_PORT", szval) == 1)
    {
        if (StrComp(Edit_Work_Port->Text.c_str(), szval) != 0)
         return 0;
    }
    //ip
    if (ZN_GetDevConfigUDP("CAN1_DES_IP1", szval) == 1)
    {
        if (StrComp(Edit_Desip_1->Text.c_str(), szval) != 0)
               return 0;
    }

    //Ŀ˿
    if (ZN_GetDevConfigUDP("CAN1_DES_PORT1", szval) == 1)
    {
        if (StrComp(Edit_DesPort_1->Text.c_str(), szval) != 0)
               return 0;
    }
    //
    if (ZN_GetDevConfigUDP("CAN1_BAUD", szval) != 1)
    {
        if (StrComp(Edit_Can_Baud->Text.c_str(), szval) != 0)
               return 0;
    }
    //ģʽ
    if (ZN_GetDevConfigUDP("CAN1_LISTEN_MD", szval) != 1)
    {
        if (StrComp(Edit_Can_Mode->Text.c_str(), szval) != 0)
                return 0;
    }

    return 1;
}

int TForm1::Modify_CanOld(AnsiString szmac, BYTE devtype, AnsiString szip)
{
    int res;
    AnsiString szpwd;

    Form2->ShowModal();
    if(Form2->isOK() == 0)
        return 0;
    szpwd = Form2->Edit1->Text;
    
    ZN_ResetModifyConfigUDP();
    if (ZN_SetModifyConfigUDP("C1_PORT",Edit_Work_Port->Text.c_str()) != 1)
        return 0;

    if (ZN_SetModifyConfigUDP("CANDESIP1",Edit_Desip_1->Text.c_str() ) != 1)
        return 0;

    if (ZN_SetModifyConfigUDP("CANDESPORT1", Edit_DesPort_1->Text.c_str()) != 1)
        return 0;

    if (ZN_SetModifyConfigUDP("CANBAUD1",Edit_Can_Baud->Text.c_str()) != 1)
    	return 0;

    if (ZN_SetModifyConfigUDP("CANLISTENMD1", Edit_Can_Mode->Text.c_str()) != 1)
	return 0;

    if (ZN_ModifyDevUDPbyMACAndIP(szmac.c_str(), szip.c_str(), szpwd.c_str(), devtype) != 1)
    	return 0;
	
    Sleep(4000);
	//УǷĳɹ
    if (ZN_GetDevInfoUDPbyMACAndIP(szmac.c_str(), szip.c_str(), devtype) != 1)
        return 0;

    char szval[32];
    //˿
    if (ZN_GetDevConfigUDP("CAN1_WORK_PORT", szval) == 1)
    {
        if (StrComp(Edit_Work_Port->Text.c_str(), szval) != 0)
         return 0;
    }
    //ip
    if (ZN_GetDevConfigUDP("CAN1_DES_IP1", szval) == 1)
    {
        if (StrComp(Edit_Desip_1->Text.c_str(), szval) != 0)
               return 0;
    }

    //Ŀ˿
    if (ZN_GetDevConfigUDP("CAN1_DES_PORT1", szval) == 1)
    {
        if (StrComp(Edit_DesPort_1->Text.c_str(), szval) != 0)
               return 0;
    }
    //
    if (ZN_GetDevConfigUDP("CAN1_BAUD", szval) != 1)
    {
        if (StrComp(Edit_Can_Baud->Text.c_str(), szval) != 0)
               return 0;
    }
    //ģʽ
    if (ZN_GetDevConfigUDP("CAN1_LISTEN_MD", szval) != 1)
    {
        if (StrComp(Edit_Can_Mode->Text.c_str(), szval) != 0)
                return 0;
    }

    return 1;
}


