unit ZNetCoreDll;
(*
----------------------------------------------------------------------------
------------ԭcͷļתdelphiʹõĸʽ---------------------------
----------------------------------------------------------------------------
#ifndef _ZNETCOREDLL_H
#define _ZNETCOREDLL_H


#define ENETCORE_EQUNAME		 0
#define ENETCORE_PASSWORD		 1
#define ENETCORE_IP				 2
#define ENETCORE_MARK			 3
#define ENETCORE_GATE			 4
#define ENETCORE_DNS			 5
#define ENETCORE_MAC_PREV		 6
#define ENETCORE_DHCP			 7
#define ENETCORE_WEB_PORT		 8
#define ENETCORE_CMD_PORT		 9
#define ENETCORE_DOWNLOAD		 10
#define ENETCORE_FIX_2LEN		 11
#define ENETCORE_FIX_2CHECK		 12
#define ENETCORE_FIX_2VERSION	 13
#define ENETCORE_FIX_1LEN		 14
#define ENETCORE_FIX_1CHECK		 15
#define ENETCORE_FIX_UPDATE		 16
#define ENETCORE_FIX_1VERSION	 17
#define ENETCORE_MAC			 18
#define ENETCORE_PRO_VERSION	 19
//////////////////////////////////////////////////////////////////////////
#define ENETCORE_DATA_DO			 25
#define ENETCORE_DATA_AI_1		     26
#define ENETCORE_DATA_AI_2		     27
#define ENETCORE_DATA_AI_3		     28
#define ENETCORE_DATA_AI_4		     29
#define ENETCORE_DATA_AI_5		     30
#define ENETCORE_DATA_AI_6		     31



#define ENETCORE_SET_DO_1			 32
#define ENETCORE_SET_DO_2			 33

#define ENETCORE_SET_AI_1			 34
#define ENETCORE_SET_AI_2			 35
#define ENETCORE_SET_AI_3			 36
#define ENETCORE_SET_AI_4			 37
#define ENETCORE_SET_AI_5			 38
#define ENETCORE_SET_AI_6			 39	
//////////////////////////////////////////////////////////////////////////
typedef struct _tagSubInfo
{
	BYTE addr;
	BYTE code[2];
	BYTE type[2];
	BYTE mode[2];
	BYTE hardver[2];
	BYTE firmver[2];
	BYTE sercode[4];
	_tagSubInfo(){}
	_tagSubInfo& operator=(const _tagSubInfo& t)
	{
		addr = t.addr;
		memcpy(code,t.code,2);	memcpy(type,t.type,2);
		memcpy(mode,t.mode,2);	memcpy(hardver,t.hardver,2);
		memcpy(firmver,t.firmver,2);	memcpy(sercode,t.sercode,4);
		return *this;
	}
	_tagSubInfo(const _tagSubInfo& t)
	{
		addr = t.addr;	
		memcpy(code,t.code,2);	memcpy(type,t.type,2);
		memcpy(mode,t.mode,2);	memcpy(hardver,t.hardver,2);
		memcpy(firmver,t.firmver,2);	memcpy(sercode,t.sercode,4);
	}
}tagSubInfo;

typedef struct _tagSubRet
{
	BYTE recode[13];
	_tagSubInfo subInfo[8];
	_tagSubRet(){}
	_tagSubRet(const _tagSubRet& t)
	{
		memcpy(recode,t.recode,CMD_HEAD_LEN);
		for(int i=0;i<8;i++)
			subInfo[i] = t.subInfo[i];
	}
	_tagSubRet& operator=(const _tagSubRet& t)
	{
		memcpy(recode,t.recode,CMD_HEAD_LEN);
		for(int i=0;i<8;i++)
			subInfo[i] = t.subInfo[i];
		return *this;
	}
}tagSubRet;



typedef struct _tagSearchRet
{
	BYTE code[4];
	BYTE mac[6];
	BYTE rec;
	BYTE equType[2];
	BYTE equCode[2];
	BYTE ipMode;
	BYTE version[2];
	BYTE ip[4];
	BYTE cmdPort[2];
	BYTE endCode;
	
	_tagSubRet			subRet_2;	
	_tagSearchRet(){}
	_tagSearchRet(const tagSearchRet& t)
	{
		memcpy(code,t.code,4);	memcpy(mac,t.mac,6);
		memcpy(equType,t.equType,2);	memcpy(equCode,t.equCode,2);
		ipMode = t.ipMode;	memcpy(version , t.version,2);
		memcpy(ip,t.ip,4);	memcpy(cmdPort,t.cmdPort,2);
		endCode = t.endCode;	subRet_2 = t.subRet_2;
	}

	_tagSearchRet& operator=(const tagSearchRet& t)
	{
		memcpy(code,t.code,4);	memcpy(mac,t.mac,6);
		memcpy(equType,t.equType,2);	memcpy(equCode,t.equCode,2);
		ipMode = t.ipMode;	memcpy(version , t.version,2);
		memcpy(ip,t.ip,4);	memcpy(cmdPort,t.cmdPort,2);
		endCode = t.endCode;	subRet_2 = t.subRet_2;
		return *this;
	}

}tagSearchRet,DEVDATA;


long __stdcall ZEN_InitSearchSocket();
long __stdcall ZEN_SearchAll();
long __stdcall ZEN_InitSearchByIpSocket(char* strIp);
long __stdcall ZEN_SearchByIP();
long __stdcall ZEN_GetSearchDev(void *outP);
long __stdcall ZEN_GetSearchByIPDev(void *outP);
long __stdcall ZEN_SetOpertingEqument(char *strIp,BYTE* macaddr,int nType);

long __stdcall ZEN_SetConnectTCP();
long __stdcall ZEN_SetConnectUDP();//sockҪ

long __stdcall ZEN_DisConnectTCP();
long __stdcall ZEN_DisConnectUDP();

//ȱ֤Բ豸Ѿѡ񣬲ӵĲ
//readһΰϢȡڴ
//getmodifyԶڴбݽжд
//޸ݺҪʹsubmodify޸ĵݽύ
//豸ύ޸ĵҪ豸
long __stdcall ZEN_ReadPropertyUDP();
long __stdcall ZEN_ReadPropertyTCP();

long __stdcall ZEN_GetPropertyByType(int nType,void *outP);
long __stdcall ZEN_ModifyPropertyByType(int nType,BYTE* inP);

long __stdcall ZEN_SubmitModifyUDP(BYTE *pwd);
long __stdcall ZEN_SubmitModifyTCP(BYTE *pwd);

long __stdcall ZEN_ReBootEqument();
long __stdcall ZEN_ReBootEqumentTCP();
long __stdcall ZEN_ReBootEqumentUDP();

//豸Ĳ
long __stdcall ZEN_SearchSubEqumentUDP();
long __stdcall ZEN_SearchSubEqumentTCP();
long __stdcall ZEN_GetSearchSubEqumentUDP(void *outP);
long __stdcall ZEN_GetSearchSubEqumentTCP(void *outP);
//ӵ豸豸ĳЩ˿ڵĲ൱ڲ豸
long __stdcall ZEN_SetOpertingSubEqument(int subAddr,short nType,short nMode);
long __stdcall ZEN_ReadSubPropertyUDP();
long __stdcall ZEN_ReadSubPropertyTCP();
long __stdcall ZEN_ReadSubDataTCP();
long __stdcall ZEN_ReadSubDataUDP();
long __stdcall ZEN_GetSubDataByType(int nDataType,void *outP);
long __stdcall ZEN_GetSubPropertyByType(int nSubType,void *outP);
long __stdcall ZEN_ModifySubProperytByType(int nSubType,void *inP);
long __stdcall ZEN_ModifySubDataByType(int nDataType,void* inP);
long __stdcall ZEN_SubmitSubModifyPropertyUDP(BYTE* subType,BYTE *subSn);
long __stdcall ZEN_SubmitSubModifyPropertyTCP(BYTE *subType,BYTE *subSn);
long __stdcall ZEN_SubmitSubDataTCP(BYTE *subType,BYTE *subSn);
long __stdcall ZEN_SubmitSubDataUDP(BYTE *subType,BYTE *subSn);

long __stdcall ZEN_ModifySubAddressUDP(BYTE* subType,BYTE* subSn,BYTE addr);
long __stdcall ZEN_ModifySubAddressTCP(BYTE* subType,BYTE* subSn,BYTE addr);
long __stdcall ZEN_ReBootSubEqumentTCP();
long __stdcall ZEN_ReBootSubEqumentUDP();

long __stdcall ZEN_UpdateFirm(BYTE *pwd,void* inP,int FileLen);

#endif
*)
interface

const DLL_NAME = 'znetcoredll.dll'    ;

const ENETCORE_EQUNAME	=	 0      ;
const ENETCORE_PASSWORD	 =	 1    ;
const ENETCORE_IP				= 2       ;
const ENETCORE_MARK			= 3       ;
const ENETCORE_GATE			= 4       ;
const ENETCORE_DNS			= 5       ;
const ENETCORE_MAC_PREV	 =	 6    ;
const ENETCORE_DHCP			= 7       ;
const ENETCORE_WEB_PORT	=	 8      ;
const ENETCORE_CMD_PORT	= 9       ;
const ENETCORE_DOWNLOAD	=	 10     ;
const ENETCORE_FIX_2LEN	 =	 11   ;
const ENETCORE_FIX_2CHECK	 =	 12 ;
const ENETCORE_FIX_2VERSION	= 13  ;
const ENETCORE_FIX_1LEN		 =14    ;
const ENETCORE_FIX_1CHECK		= 15  ;
const ENETCORE_FIX_UPDATE		= 16  ;
const ENETCORE_FIX_1VERSION	= 17  ;
const ENETCORE_MAC			     = 18 ;
const ENETCORE_PRO_VERSION	= 19  ;
/////////////////////////////////////////////////////////////////////////
const ENETCORE_DATA_DO		   	  = 25    ;
const ENETCORE_DATA_AI_1		    =  26   ;
const ENETCORE_DATA_AI_2		    =  27   ;
const ENETCORE_DATA_AI_3		    =  28   ;
const ENETCORE_DATA_AI_4		    = 29    ;
const ENETCORE_DATA_AI_5		    = 30    ;
const ENETCORE_DATA_AI_6		    = 31    ;



const ENETCORE_SET_DO_1		 =	 32      ;
const ENETCORE_SET_DO_2		 =	 33      ;

const ENETCORE_SET_AI_1		 =	 34      ;
const ENETCORE_SET_AI_2		 =	 35      ;
const ENETCORE_SET_AI_3		 =	 36      ;
const ENETCORE_SET_AI_4		 =	 37      ;
const ENETCORE_SET_AI_5		 =	 38      ;
const ENETCORE_SET_AI_6		 =	 39      ;






function ZEN_InitSearchSocket () : integer;
  stdcall;
  external DLL_NAME;

function ZEN_SearchAll () : integer;
  stdcall;
  external DLL_NAME;

function ZEN_GetSearchDev (pData:Pbyte) : integer;
  stdcall;
  external DLL_NAME;

implementation

end.
 