#ifndef ZNETADV_HEADER
#define ZNETADV_HEADER


#define TYPE_ZNE100			0x01
#define TYPE_ZNE100T		0x02
#define TYPE_ZNE10			0x03
#define TYPE_ZNE200T		0x04
#define TYPE_ZNETCOM10S		0x05
#define TYPE_ZNE200			0x06
#define TYPE_ZNE10T			0x07
#define TYPE_ZNE100TI		0x08
#define TYPE_NETCOMBASIC	0x09
#define TYPE_CANETE			0x11
#define TYPE_CANET100		0x12
#define TYPE_CANET200		0x13
#define TYPE_CANET100T		0x14
#define TYPE_CANET200T		0x15

#define TYPE_CANET_ET		0x16
#define TYPE_CANET_2ET		0x17
#define TYPE_CANET_4E       0x80
#define TYPE_CANET_2E       0x90
#define TYPE_CANSWITCH_AN2S2_SWITCH 0x96
#define TYPE_CANSWITCH_AN2S2_ROUTER 0x95
#define TYPE_CANET_E        0xa0
#define TYPE_CANWIFI_2      0xF0
#define TYPE_CANET_E_P      0xEC

#define TYPE_ZNE300T		0x20
#define TYPE_ZNE100TL		0X22
#define TYPE_IPORT_1		0X23
#define TYPE_ZNE100SL		0X24
#define TYPE_MPORT100		0X28
#define TYPE_NETCOM400		0x30
#define TYPE_NETCOM400SEF	0x31
#define TYPE_NETCOM200		0x38
#define TYPE_NETCOM800		0x40
#define TYPE_NETCOM800A		0X41
#define TYPE_NETCOM400IE	0x32
#define TYPE_NETCOM200IE	0x3A

#define TYPE_WICOM			0X51

#define ZN_ERR_GETINFO			100
#define ZN_ERR_UNSUPPORTED		101
#define ZN_ERR_PWD				102
#define ZN_ERR_CONNECT			103
#define ZN_ERR_NORESPONSE		104
#define ZN_ERR_NOLOGIN			105
#define ZN_ERR_CMDINVALID		106
#define ZN_ERR_PARAFORMAT		107
#define ZN_ERR_PARANUMBER		108
#define ZN_ERR_NOBUF			109		//û㹻Ŀռ
#define	ZN_ERR_GENERAL			0
#define ZN_SUCCESS				1
#define ZN_UPDATE_SUCCESS       2
#define ZN_UPDATE_ERR           3



#ifdef __cplusplus
extern "C" {
#endif

DWORD __stdcall ZN_GetCardIP(char* arrIPs,UINT x,UINT y,UINT* retLen);//ȡIP
DWORD __stdcall ZN_OneCard(char* szip);//ѡһIP
DWORD __stdcall ZN_GetCard(char* szip);//ȡIP

DWORD __stdcall ZN_SearchAll();//㲥
DWORD __stdcall ZN_Search(char* szip);//ָ
DWORD __stdcall ZN_GetSearchDev(char* szip,char* szver,char* szmac,BYTE* pdevtype,
								BYTE* pipmode,int* ptcpport);//ȡ豸

DWORD __stdcall ZN_GetDevInfoUDPbyIP(char* szip,BYTE devtype);//ȡ豸Ϣ
DWORD __stdcall ZN_GetDevConfigUDP(char* szname,char* szval);//ȡ豸ò

DWORD __stdcall ZN_GetDevInfoUDPbyMACAndIP(char* szmac,char* szip,BYTE devtype);//ȡ豸Ϣ

DWORD __stdcall ZN_ResetModifyConfigUDP();
DWORD __stdcall ZN_SetModifyConfigUDP(char* szname,char* szval);
DWORD __stdcall ZN_ModifyDevUDPbyIP(char* szip,char* szpwd,BYTE devtype);//豸

DWORD __stdcall ZN_ModifyDevUDPbyMACAndIP(char* szmac,char* szip,char* szpwd,BYTE devtype);//豸

DWORD __stdcall ZN_LoginTCP(BYTE devtype,char* szip,int port,char* szpwd);
DWORD __stdcall ZN_GetDevConfigTCP(char* szname,char* szval);
DWORD __stdcall ZN_ModifyDevConfigTCP(char* szname,char* szval);
DWORD __stdcall ZN_ResetDevTCP();
DWORD __stdcall ZN_ExitTCP();

DWORD __stdcall ZN_SendCmd(BYTE devtype,char* szip,int port,char* szname,
						   char* szval,BYTE budp);//

HANDLE __stdcall ZN_TCPInit(char* szip,int port);
DWORD __stdcall ZN_GetAD(HANDLE hd,int* padc0,int *padc1);
DWORD __stdcall ZN_GetIO(HANDLE hd,BYTE* pdirection, BYTE* pelevel);
DWORD __stdcall ZN_SetIODir(HANDLE hd,BYTE dir);
DWORD __stdcall ZN_SetIOLevel(HANDLE hd,BYTE level);
DWORD __stdcall ZN_TCPUninit(HANDLE hd);

void __stdcall ZN_SetCommunicateType(BYTE type,CString strComName);
bool __stdcall ZN_OpenCom();
bool __stdcall ZN_CloseCom();

// DWORD __stdcall ZN_GetDevInfoUDPbyMACAndIPSingle
// DWORD __stdcall ZN_ModifyDevUDPbyMACAndIPSingle
DWORD __stdcall ZN_ModifyDevUDPbyMACAndIPSingle(char* szmac,char* szip,char* szpwd,BYTE devtype);//ȡ
//internal use
//////////////////////////////////////////////////////////////////////////
//UDP update func
DWORD __stdcall ZN_CreateUDPSocket(char *szip,int port);  // Դ˿  Ŀ˿ port UDP Socket
DWORD __stdcall ZN_IsReadySendUDP(BYTE devtype, char *szip, int port, BYTE* mac);
DWORD __stdcall ZN_SendUDPUpdateFirmeCANETNew(DWORD frameindex, BYTE* pdata, int datalen,DWORD *ReqSend); //CANET-2E,CANET-4E
DWORD __stdcall ZN_SendUDPUpdateFrame(DWORD frameindex, BYTE* pdata, int datalen,DWORD *ReqSend);
DWORD __stdcall ZN_SetUDPUpdateRecHwnd(HWND hwnd, UINT msgid);

// void __stdcall ZN_GetLanAdapterName(char* szLanAdapterName);
// BOOL __stdcall ZN_RegSetIP(LPCTSTR lpszAdapterName, LPCTSTR pIPAddress, LPCTSTR pNetMask, LPCTSTR pNetGate);
// DWORD __stdcall ZN_ChangLocalIP(int nIndex, LPCTSTR pIPAddress, LPCTSTR pNetMask, LPCTSTR pNetGate);
// BOOL __stdcall ZN_NotifyIPChange(LPCTSTR lpszAdapterName, int nIndex, LPCTSTR pIPAddress, LPCTSTR pNetMask);

//
DWORD __stdcall ZN_CloseReadSendUDP();//ر ZN_IsReadySendUDP UDP Socket

DWORD __stdcall ZN_GetDevInfoUDPbyMAC(char* szmac,BYTE devtype);//ȡ豸Ϣ
DWORD __stdcall ZN_ModifyDevUDPbyMAC(char* szmac,char* szpwd,BYTE devtype);//豸

DWORD __stdcall ZN_TCPConnect(char* szip,int port);
DWORD __stdcall ZN_TCPSend(BYTE* pbuf,int len);
DWORD __stdcall ZN_TCPExit();
DWORD __stdcall ZN_TCPSetRecHWnd(HWND hwnd,UINT msgid);
DWORD __stdcall ZN_TCPDisconnect();

#ifdef __cplusplus
};
#endif

#endif
