﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("kernel32.dll")]
        static extern void Sleep(UInt32 ms);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_SearchAll();
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_Search([MarshalAs(UnmanagedType.LPStr)] String szip);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetSearchDev( ref byte szip,
            ref byte szver,ref byte szmac,
            ref byte pdevtype, ref byte pipmode, ref int ptcpport);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevInfoUDPbyIP(
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            byte devtype);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevConfigUDP([MarshalAs(UnmanagedType.LPStr)] string szname,
            ref byte szval);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevInfoUDPbyMACAndIP([MarshalAs(UnmanagedType.LPStr)] string szmac,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            byte devtype);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ResetModifyConfigUDP();
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_SetModifyConfigUDP(
            [MarshalAs(UnmanagedType.LPStr)] string szname,
            [MarshalAs(UnmanagedType.LPStr)] string szval);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ModifyDevUDPbyIP(
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            [MarshalAs(UnmanagedType.LPStr)] string szpwd,
            byte devtype);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ModifyDevUDPbyMACAndIP(
            [MarshalAs(UnmanagedType.LPStr)] string szmac,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            [MarshalAs(UnmanagedType.LPStr)] string szpwd,
            byte devtype);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_LoginTCP(byte devtype,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            int port,
            [MarshalAs(UnmanagedType.LPStr)] string szpwd);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevConfigTCP(
            [MarshalAs(UnmanagedType.LPStr)] string szname, ref byte szval);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ModifyDevConfigTCP(
            [MarshalAs(UnmanagedType.LPStr)] string szname,
            [MarshalAs(UnmanagedType.LPStr)] string szval);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ResetDevTCP();
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ExitTCP();

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_SendCmd(byte devtype,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            int port,
            [MarshalAs(UnmanagedType.LPStr)] string szname,
            [MarshalAs(UnmanagedType.LPStr)] string szval,
            byte budp);

        const int TYPE_CANETE = 0x11;
        const int TYPE_CANET100 = 0x12;
        const int TYPE_CANET200 = 0x13;

        const int TYPE_CANET100T = 0x14;
        const int TYPE_CANET200T = 0x15;
        const int TYPE_CANET_ET	 = 0x16;
        const int TYPE_CANET_2ET = 0x17;


        
        public Form1()
        {
            InitializeComponent();
        }

        public void ClearDevices()
        {
            listView_Dev.Items.Clear();
        }
        public string GetDevType(byte devtype)
        {
            Byte []devarr=new Byte[20];
            string []namearr=new string[20];
            devarr[0] = 1;
            devarr[1] = 2;
            devarr[2] = 3;
            devarr[3] = 4;
            devarr[4] = 5;
            devarr[5] = 6;
            devarr[6] = 7;
            devarr[7] = 8;
            devarr[8] = 11;
            devarr[9] = 12;
            devarr[10] = 13;
            devarr[11] = 22;
            devarr[12] = 23;
            devarr[13] = 48;

            namearr[0] = "ZNE-100";
            namearr[1] = "ZNE-100T";
            namearr[2] = "ZNE-10";
            namearr[3] = "ZNE-200T";
            namearr[4] = "NETCOM-10";
            namearr[5] = "ZNE-200";
            namearr[6] = "ZNE-10T";
            namearr[7] = "ZNE-100TI";
            namearr[8] = "CANET-E";
            namearr[9] = "CANET-100";
            namearr[10] = "CANET-200";
            namearr[11] = "CANET_ET";
            namearr[12] = "CANET_2ET";
            namearr[13] = "NETCOM-400";

	        int sz=12,i=0;
	        string str1;
	        for(i=0;i<sz;i++)
	        {
		        if(devarr[i]==devtype)
		        {
                    str1=System.Convert.ToString(devtype)+"("+
                        namearr[i]+")";
			        return str1;
		        }
	        }
            str1=System.Convert.ToString(devtype);
	        return str1;
        }
        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            ClearDevices();
            ZN_SearchAll();
            int times=0;
            byte[] szip = new byte[20];
            byte[] szver = new byte[20];
            byte[] szmac = new byte[30];
            byte devtype=0,ipmode=0;
            int tcpport=0;
            for(;times<200;times++)
            {
                while (ZN_GetSearchDev(ref szip[0], ref szver[0], ref szmac[0], ref devtype, ref ipmode, ref tcpport) == 1)
                {
                    ListViewItem item = listView_Dev.Items.Add(
                        System.Text.Encoding.ASCII.GetString(szip));
                    item.SubItems.Add(GetDevType(devtype));
                    item.SubItems.Add(
                        System.Text.Encoding.ASCII.GetString(szmac));
                    if (devtype >= 48)
                        item.SubItems.Add(System.Convert.ToString(tcpport));
                    else
                        item.SubItems.Add("");
                }
                Sleep(10);
            }

        }

        public int TryGetSelDev()
        {
            if (listView_Dev.SelectedItems.Count > 0)
            {
                return listView_Dev.SelectedItems[0].Index;
            }
            return -1;
        }

        int GetInfo_CanOld(string szmac, byte devtype, string szip)
        {
	        if (ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype) != 1)
		        return 0;

            byte []szval=new byte[100];
            if (ZN_GetDevConfigUDP("C1_PORT", ref szval[0]) != 1)
		        return 0;
            textBox_Workport.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CANDESIP1", ref szval[0]) != 1)
		        return 0;
            textBox_dstip.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CANDESPORT1", ref szval[0]) != 1)
		        return 0;
            textBox_dstport.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CANBAUD1", ref szval[0]) != 1)
		        return 0;
            textBox_Baud.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CANLISTENMD1", ref szval[0]) != 1)
		        return 0;
            textBox_Worktype.Text = System.Text.Encoding.ASCII.GetString(szval);


            if (ZN_GetDevConfigUDP("NAME", ref szval[0]) != 1)
		        return 0;
            textBox_Name.Text = System.Text.Encoding.ASCII.GetString(szval);
        	
        	

	        return 1;
        }
        int GetInfo_CanNew( string szmac,byte devtype,string szip)
        {
        	
	        if (ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype) != 1)
		        return 0;
        	
            byte []szval=new byte[100];

            if (ZN_GetDevConfigUDP("CAN1_WORK_PORT", ref szval[0]) != 1)
		        return 0;
            textBox_Workport.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CAN1_DES_IP1", ref szval[0]) != 1)
		        return 0;
            textBox_dstip.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CAN1_DES_PORT1", ref szval[0]) != 1)
		        return 0;
            textBox_dstport.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CAN1_BAUD", ref szval[0]) != 1)
		        return 0;
            textBox_Baud.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("CAN1_LISTEN_MD", ref szval[0]) != 1)
		        return 0;
            textBox_Worktype.Text = System.Text.Encoding.ASCII.GetString(szval);

            if (ZN_GetDevConfigUDP("NAME", ref szval[0]) != 1)
		        return 0;
            textBox_Name.Text = System.Text.Encoding.ASCII.GetString(szval);

	        return 1;

        }

        private void button2_Click(object sender, EventArgs e)
        {
	        int selind=TryGetSelDev();
	        if(selind==-1)
	        {
		        return;
	        }
            string szip = "",str1="";
            string szmac = "";
	        byte devtype=0;
	        int tcpport=0;
            szip=listView_Dev.Items[selind].Text;
            szmac = listView_Dev.Items[selind].SubItems[2].Text;
            str1 = listView_Dev.Items[selind].SubItems[1].Text;
            if(str1.IndexOf('(')!=-1)
                str1 = str1.Substring(0,str1.IndexOf('('));
            devtype = System.Convert.ToByte(str1);
            str1 = listView_Dev.Items[selind].SubItems[3].Text;
	        if(str1!="")
                tcpport = System.Convert.ToInt32(str1);
	        int res=0;

            if (devtype == TYPE_CANET100 || devtype == TYPE_CANET200 || devtype == TYPE_CANETE)
            {
                res = GetInfo_CanOld(szmac, devtype, szip);
            }
            else if (devtype == TYPE_CANET200T || devtype == TYPE_CANET100T || devtype == TYPE_CANET_ET || devtype == TYPE_CANET_ET)
            {
                res = GetInfo_CanNew(szmac, devtype, szip);
            }
            else
            {
                MessageBox.Show("不支持的设备", "错误", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }


	        if(res!=1)
                MessageBox.Show("获取信息失败", "错误",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	        else
                MessageBox.Show("获取信息成功", "信息",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        int Modify_CanNew(string szmac, byte devtype, string szip)
        {
            Form2 dlg=new Form2();
            dlg.ShowDialog();
            if(dlg.isOK()!=1)
	            return 0;
            string szpwd="";
            szpwd=dlg.GetPwd();

            ZN_ResetModifyConfigUDP();
            uint res = 1;
            res = ZN_SetModifyConfigUDP("NAME", textBox_Name.Text);
            res = ZN_SetModifyConfigUDP("CAN1_LISTEN_MD", textBox_Worktype.Text);
            res = ZN_SetModifyConfigUDP("CAN1_WORK_PORT", textBox_Workport.Text);
            res = ZN_SetModifyConfigUDP("CAN1_BAUD", textBox_Baud.Text);
            res = ZN_SetModifyConfigUDP("CAN1_DES_IP1", textBox_dstip.Text);
            res = ZN_SetModifyConfigUDP("CAN1_DES_PORT1", textBox_dstport.Text);

            if (ZN_ModifyDevUDPbyMACAndIP(szmac, szip, szpwd, devtype) != 1)
                return 0;
        	
	        Sleep(4000);
	        //校验是否更改成功
	        if (ZN_GetDevInfoUDPbyMACAndIP(szmac,  szip, devtype) != 1)
		        return 0;
        	
            byte[] szvalnew=new byte[100];
        	
	        //工作端口
	        if (ZN_GetDevConfigUDP("CAN1_WORK_PORT", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_Workport.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //ip
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CAN1_DES_IP1", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_dstip.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //目标端口
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CAN1_DES_PORT1", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_dstport.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //波特率
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CAN1_BAUD", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_Baud.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //工作模式
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CAN1_LISTEN_MD", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_Worktype.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;     
   	
	        return 1;
        }
        int Modify_CanOld(string szmac, byte devtype, string szip)
        {
            Form2 dlg=new Form2();
            dlg.ShowDialog();
            if(dlg.isOK()!=1)
	            return 0;
            string szpwd="";
            szpwd=dlg.GetPwd();

            ZN_ResetModifyConfigUDP();
            uint res = 1;
            res = ZN_SetModifyConfigUDP("NAME", textBox_Name.Text);
            res = ZN_SetModifyConfigUDP("CANLISTENMD1", textBox_Worktype.Text);
            res = ZN_SetModifyConfigUDP("C1_PORT", textBox_Workport.Text);
            res = ZN_SetModifyConfigUDP("CANBAUD1", textBox_Baud.Text);
            res = ZN_SetModifyConfigUDP("CANDESIP1", textBox_dstip.Text);
            res = ZN_SetModifyConfigUDP("CANDESPORT1", textBox_dstport.Text);


	        if (ZN_ModifyDevUDPbyMACAndIP(szmac, szip, szpwd, devtype) != 1)
		        return 0;

	        //校验是否更改成功
	        if (ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype) != 1)
		        return 0;

            byte[] szvalnew=new byte[100];

	        //工作端口
	        if (ZN_GetDevConfigUDP("C1_PORT", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_Workport.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //ip
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CANDESIP1", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_dstip.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //目标端口
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CANDESPORT1", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_dstport.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //波特率
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CANBAUD1", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_Baud.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;
	        //工作模式
            szvalnew = new byte[100];
	        if (ZN_GetDevConfigUDP("CANLISTENMD1", ref szvalnew[0]) != 1)
		        return 0;
            if (System.String.Compare(textBox_Worktype.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                return 0;

	        return 1;
        	
        }
        private void button3_Click(object sender, EventArgs e)
        {
	        int selind=TryGetSelDev();
	        if(selind==-1)
	        {
		        return;
	        }
            string szip = "", str1 = "";
            string szmac = "";
            byte devtype = 0;
            int tcpport = 0;
            szip = listView_Dev.Items[selind].Text;
            szmac = listView_Dev.Items[selind].SubItems[2].Text;

            str1 = listView_Dev.Items[selind].SubItems[1].Text;
            if (str1.IndexOf('(') != -1)
                str1 = str1.Substring(0, str1.IndexOf('('));
            devtype = System.Convert.ToByte(str1);
            str1 = listView_Dev.Items[selind].SubItems[3].Text;
            if (str1 != "")
                tcpport = System.Convert.ToInt32(str1);
            int res=0;

            if (devtype == TYPE_CANET100 || devtype == TYPE_CANET200 || devtype == TYPE_CANETE)
            {
                res = Modify_CanOld(szmac, devtype, szip);
            }
            else if (devtype == TYPE_CANET200T || devtype == TYPE_CANET100T || devtype == TYPE_CANET_ET || devtype == TYPE_CANET_ET)
            {
                res = Modify_CanNew(szmac, devtype, szip);
            }
            else
            {   
                MessageBox.Show("不支持的设备", "错误",MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }


	        if(res!=1)
                MessageBox.Show("更改信息失败", "错误",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	        else
                MessageBox.Show("更改信息成功", "信息",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
    }
}