unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,ZNetAdv,Unit2;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Edit_Name: TEdit;
    Label8: TLabel;
    Edit_Work_PORT: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Edit_CAN_DES_IP1: TEdit;
    Edit_CAN_DES_PORT1: TEdit;
    Edit_CAN1_BAUD: TEdit;
    GroupBox2: TGroupBox;
    ListView_Dev: TListView;
    Label2: TLabel;
    Label3: TLabel;
    Edit_CAN_Mode: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
  published
    function GetDevType(devtype: BYTE): AnsiString;
    procedure ClearDevices;
    function TryGetSelDev: integer;

  {
    function GetInfo_SingleCOM(devtype: BYTE; szip: AnsiString): integer;
    function Modify_MultiCOM(devtype: BYTE; szip: AnsiString;
      tcpport: integer): integer;
    function GetInfo_MultiCOM(devtype: BYTE; szip: AnsiString;
      tcpport: integer): integer;
    function Modify_SingleCOM(devtype: BYTE; szip: AnsiString): integer;
  }

    //ȡCANϢ
    function GetInfo_CanetOld(devtype: BYTE; szip :AnsiString;
    szmac: AnsiString): integer;
    function GetInfo_CanetNew(devtype: BYTE; szip :AnsiString; 
      szMac: AnsiString): integer;
    //  
    function Modify_CanetOld(devtype: BYTE; szip: AnsiString;
    szmac: AnsiString ): integer;
    function Modify_CanetNew(devtype: BYTE; szip: AnsiString;
      szmac: AnsiString): integer;

    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
times:integer;
szip : array[0..20] of CHAR;
szver : array[0..20] of CHAR;
szmac: array[0..30] of CHAR;
devtype: BYTE;
ipmode: BYTE;
tcpport: integer;
item: TListItem;
begin
	ClearDevices();
	ZN_SearchAll();
  times:=200;
	while(times>0) do
  begin
		while(ZN_GetSearchDev(@szip[0],@szver[0],@szmac[0],@devtype,@ipmode,@tcpport)=1) do
		begin
      item:=ListView_Dev.Items.Add();
      item.Data:=Pointer(devtype);
      item.Caption:=szip;
      item.SubItems.Add(GetDevType(devtype));
      item.SubItems.Add(szmac);
			if(devtype>=48) then
          item.SubItems.Add(IntToStr(tcpport))
      else
          item.SubItems.Add('');
		end;
		Sleep(10);
    times:=times-1;
	end;

end;

procedure TForm1.ClearDevices;
begin
    ListView_Dev.Items.Clear();
end;

function TForm1.GetDevType(devtype: BYTE): AnsiString;
var
strtype:AnsiString;
devarr: array[0..20] of BYTE;
namearr: array[0..20] of AnsiString;
i: integer;
begin
    devarr[0] := 1;
    devarr[1] := 2;
    devarr[2] := 3;
    devarr[3] := 4;
    devarr[4] := 5;
    devarr[5] := 6;
    devarr[6] := 7;
    devarr[7] := 8;
    devarr[8] := 0x11;
    devarr[9] := 0x12;
    devarr[10] := 0x13;
    devarr[11] := 48;	
	devarr[12] := 22;
	devarr[13] := 23;
    devarr[14] := 20;
    devarr[15] := 21;


    namearr[0] := 'ZNE-100';
    namearr[1] := 'ZNE-100T';
    namearr[2] := 'ZNE-10';
    namearr[3] := 'ZNE-200T';
    namearr[4] := 'NETCOM-10';
    namearr[5] := 'ZNE-200';
    namearr[6] := 'ZNE-10T';
    namearr[7] := 'ZNE-100TI';
    namearr[8] := 'CANET-E';
    namearr[9] := 'CANET-100';
    namearr[10] := 'CANET-200';
    namearr[11] := 'NETCOM-400';
	namearr[12] := 'CANET_ET';
	namearr[13] := 'CANET_2ET';
    namearr[14] := 'CANET-100T';
    namearr[15] := 'CANET-200T';


    strtype := IntToStr(devtype);
    For i:= 0 To 15 do
    begin
        If(devarr[i]=devtype) Then
            strtype := strtype + '(' + namearr[i] + ')';
    end;
    GetDevType := strtype;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
selind:integer;
szip,szmac,str1: AnsiString;
devtype: BYTE;
tcpport,res: integer;
begin
    selind := TryGetSelDev();
    If(selind = -1) Then
        Exit;
    szip:=ListView_Dev.Items.Item[selind].Caption;
    str1:=ListView_Dev.Items.Item[selind].SubItems[0];
    devtype:=BYTE(ListView_Dev.Items.Item[selind].Data);
    szmac:=ListView_Dev.Items.Item[selind].SubItems[1];
    str1:=ListView_Dev.Items.Item[selind].SubItems[2];


    If(devtype = 18) or (devtype = 19) then
        res := GetInfo_CanetOld(devtype, szip, szmac)
    else if (devtype = 20) or (devtype = 21) then
        res := GetInfo_CanetNew(devtype, szip, szmac)
    else
    begin
        ShowMessage('ֵ֧豸');
        Exit;
    end;


    If (res <> 1) Then
        ShowMessage ('ȡϢʧ')
    Else
        ShowMessage ('ȡϢɹ');
end;

procedure TForm1.Button3Click(Sender: TObject);
var
selind:integer;
szip,str1 , szmac:AnsiString;
devtype:BYTE;
tcpport:integer;
res:integer;
begin
    selind := TryGetSelDev();
    If(selind = -1) Then
        Exit;
    szip:=ListView_Dev.Items.Item[selind].Caption;
    str1:=ListView_Dev.Items.Item[selind].SubItems[0];   
    szmac:=ListView_Dev.Items.Item[selind].SubItems[1];
    devtype:=BYTE(ListView_Dev.Items.Item[selind].Data);
    str1:=ListView_Dev.Items.Item[selind].SubItems[2];
    If(str1<>'') Then
        tcpport := StrToInt(str1);

    If(devtype = 18) or (devtype = 19) then
        res := Modify_CanetOld(devtype, szip, szmac)
    else if (devtype = 20) or (devtype = 21) or (devtype = 0x16) or (devtype = 0x17) then
        res := Modify_CanetNew(devtype, szip, szmac)
    else
      ShowMessage ('ֵ֧豸');

    If (res <> 1) Then
        ShowMessage ('Ϣʧ')
    Else
        ShowMessage ('Ϣɹ');
end;


function TForm1.TryGetSelDev: integer;
begin
    If(ListView_Dev.SelCount=0) Then
    begin
        ShowMessage ('ѡһ豸');
        TryGetSelDev := -1;
        Exit;
    end;
    TryGetSelDev := ListView_Dev.Selected.Index;
end;

function TForm1.GetInfo_CanetOld(devtype: BYTE;
  szip: AnsiString ; szmac: AnsiString): integer;
var
res:integer;
szval:array[0..100] of CHAR;
begin
    res := ZN_GetDevInfoUDPbyMACAndIP(PChar(szmac),PChar(szip),devtype);
    If (res <> 1) Then
    begin
        GetInfo_CanetOld := 0;
        Exit;
    end;

    res := ZN_GetDevConfigUDP('NAME', @szval[0]);
    If (res = 1) Then
        Edit_Name.Text :=szval;

    res := ZN_GetDevConfigUDP('C1_PORT', @szval[0]);
    If res = 1 Then
    Edit_Work_PORT.Text := szval;

    res := ZN_GetDevConfigUDP('CANDESIP1', @szval[0]);
    If res = 1 Then
        Edit_CAN_DES_IP1.Text := szval;

    res := ZN_GetDevConfigUDP('CANDESPORT1', @szval[0]);
    If res = 1 Then
        Edit_CAN_DES_PORT1.Text := szval;

    res := ZN_GetDevConfigUDP('CANBAUD1', @szval[0]);
    If res = 1 Then
        Edit_CAN1_BAUD.Text := szval;

    res := ZN_GetDevConfigUDP('CANLISTENMD1', @szval[0]);
    If res = 1 Then
      Edit_CAN_Mode.Text := szval;
      
    GetInfo_CanetOld := res;
end;

function TForm1.GetInfo_CanetNew(devtype: BYTE;
  szip: AnsiString; szMac: AnsiString): integer;
var
res:integer;
szval:array[0..100] of CHAR;
begin
    res := ZN_GetDevInfoUDPbyMacAndIP(PChar(szMac), PChar(szip),devtype);
    If (res <> 1) Then
    begin
        GetInfo_CanetNew := 0;
        Exit;
    end;

    res := ZN_GetDevConfigUDP('NAME', @szval[0]);
    If (res = 1) Then
        Edit_Name.Text :=szval;

    res := ZN_GetDevConfigUDP('CAN1_WORK_PORT', @szval[0]);
    If res = 1 Then
    Edit_Work_PORT.Text := szval;

    res := ZN_GetDevConfigUDP('CAN1_DES_IP1', @szval[0]);
    If res = 1 Then
        Edit_CAN_DES_IP1.Text := szval;

    res := ZN_GetDevConfigUDP('CAN1_DES_PORT1', @szval[0]);
    If res = 1 Then
        Edit_CAN_DES_PORT1.Text := szval;

    res := ZN_GetDevConfigUDP('CAN1_BAUD', @szval[0]);
    If res = 1 Then
        Edit_CAN1_BAUD.Text := szval;

    res := ZN_GetDevConfigUDP('CAN1_LISTEN_MD', @szval[0]);
    If res = 1 Then
      Edit_Can_Mode.Text := szval;

    GetInfo_CanetNew := res;
end;

function TForm1.Modify_CanetOld(devtype: BYTE; szip: AnsiString; szmac: AnsiString): integer;
var
res:integer;
szpwd:AnsiString;
szvalnew:array[0..100] of CHAR;
begin
    Form2.ShowModal();
    If(Form2.isOK() = 0) Then
    begin
        Modify_CanetOld := 0;
        Exit;
    end;
    szpwd := Form2.Edit1.Text;

    ZN_ResetModifyConfigUDP;
    
    res := ZN_SetModifyConfigUDP('NAME', PChar(Edit_Name.Text));
    res := ZN_SetModifyConfigUDP('C1_PORT', PChar(Edit_WORK_PORT.Text));
    res := ZN_SetModifyConfigUDP('CANDESIP1', PChar(Edit_CAN_DES_IP1.Text));
    res := ZN_SetModifyConfigUDP('CANDESPORT1', PChar(Edit_CAN_DES_PORT1.Text));
    res := ZN_SetModifyConfigUDP('CANBAUD1', PChar(Edit_CAN1_BAUD.Text));
    res := ZN_SetModifyConfigUDP('CANLISTENMD1', PChar(Edit_CAN_Mode.Text));

    res := ZN_ModifyDevUDPbyMACAndIP(PChar(szmac), PChar(szip), PChar(szpwd), devtype);
    If (res <> 1) Then
    begin
        Modify_CanetOld := 0;
        Exit;
    end;
    Sleep (500);

    res := ZN_GetDevInfoUDPbyMACAndIP(PChar(szmac), PChar(szip), devtype);
    If (res <> 1) Then
    begin
        Modify_CanetOld := 0;
        Exit;
    end;
    
    
    If (ZN_GetDevConfigUDP('NAME', @szvalnew[0]) = 1) Then
    begin
        If(StrComp(PChar(Edit_Name.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetOld := 0;
            Exit;
        end;
    end;

    If (ZN_GetDevConfigUDP('C1_PORT', @szvalnew[0]) = 1) Then
    begin
        If (StrComp(PChar(Edit_Work_PORT.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetOld := 0;
            Exit;
        end;
    end;
    
    If ZN_GetDevConfigUDP('CANDESIP1', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_CAN_DES_IP1.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetOld := 0;
            Exit;
        end;
    end;
    
    If ZN_GetDevConfigUDP('CANDESPORT1', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_CAN_DES_PORT1.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetOld := 0;
            Exit;
        end;
    end;

    If ZN_GetDevConfigUDP('CANBAUD1', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_CAN1_BAUD.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetOld := 0;
            Exit;
        end;
    end;

    Modify_CanetOld := 1;

end;

function TForm1.Modify_CanetNew(devtype: BYTE; szip: AnsiString;
  szMac: AnsiString): integer;
var
res:integer;
szpwd:AnsiString;
szvalnew:array[0..100] of CHAR;
begin
    Form2.ShowModal();
    If(Form2.isOK() = 0) Then
    begin
        Modify_CanetNew := 0;
        Exit;
    end;
    szpwd := Form2.Edit1.Text;

    ZN_ResetModifyConfigUDP;
    
    res := ZN_SetModifyConfigUDP('NAME', PChar(Edit_Name.Text));
    res := ZN_SetModifyConfigUDP('CAN1_WORK_PORT', PChar(Edit_Work_PORT.Text));
    res := ZN_SetModifyConfigUDP('CAN1_DES_IP1', PChar(Edit_CAN_DES_IP1.Text));
    res := ZN_SetModifyConfigUDP('CAN1_DES_PORT1', PChar(Edit_CAN_DES_PORT1.Text));
    res := ZN_SetModifyConfigUDP('CAN1_BAUD', PChar(Edit_CAN1_BAUD.Text)); 
    res := ZN_SetModifyConfigUDP('CAN1_LISTEN_MD', PChar(Edit_CAN_Mode.Text));


    res := ZN_ModifyDevUDPbyMACAndIP(PChar(szMac), PChar(szip), PChar(szpwd), devtype );
    If (res <> 1) Then
    begin
        Modify_CanetNew := 0;
        Exit;
    end;
    Sleep (4000);

    
    res := ZN_GetDevInfoUDPbyMACAndIP(PChar(szMac), PChar(szip), devtype);
    If (res <> 1) Then
    begin
        Modify_CanetNew := 0;
        Exit;
    end;
    
    
    If (ZN_GetDevConfigUDP('NAME', @szvalnew[0]) = 1) Then
    begin
        If(StrComp(PChar(Edit_Name.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetNew := 0;
            Exit;
        end;
    end;

    If (ZN_GetDevConfigUDP('CAN1_WORK_PORT', @szvalnew[0]) = 1) Then
    begin
        If (StrComp(PChar(Edit_WORK_PORT.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetNew := 0;
            Exit;
        end;
    end;
    
    If ZN_GetDevConfigUDP('CAN1_DES_IP1', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_CAN_DES_IP1.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetNew := 0;
            Exit;
        end;
    end;
    
    If ZN_GetDevConfigUDP('CAN1_DES_PORT1', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_CAN_DES_PORT1.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetNew := 0;
            Exit;
        end;
    end;

    If ZN_GetDevConfigUDP('CAN1_BAUD', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_CAN1_BAUD.Text),@szvalnew[0])<>0) Then
        begin
            Modify_CanetNew := 0;
            Exit;
        end;
    end;

    Modify_CanetNew := 1;

end;

end.
